﻿DGW_CONTROL_BLOCK dcb;
HANDLE hDGW = INVALID_HANDLE;
HANDLE hSerial = INVALID_HANDLE;

// Array of pointers to label widgets that show the lamp output level
static tLabel* pLamp[3] = {&Label6,  &Label7, &Label8};

void Frame10211OnCreate()
{
  if ( hSerial == INVALID_HANDLE ) // first time initial
  {
    hSerial = uart_Open("COM1,9600,8N1");
    if ( hSerial != INVALID_HANDLE )
    {
       hDGW = dgw_Init(hSerial, 1, &dcb); // serial handle, modbus ID, DGW Control Block

       dgw_SetOperationMode(hDGW, DGW_AUTO_LAMPS_GROUPS);
    }
  }
}

void Timer228OnExecute(tWidget *pWidget)
{
  static char szMsg0[30];
  usprintf(szMsg0, "Handle: %d", hDGW); // show DGW handle
  LabelTextSet(&Label2, szMsg0);

// State : idle or busy
// DGW_INIT               0
// DGW_SCAN               1
// DGW_IDLE               2
// DGW_READY              2 // same as idle
// DGW_BUSY               3

  static char szMsg1[30];
  usprintf(szMsg1, "State: %d", dgw_State(hDGW) ); // show DGW state
  LabelTextSet(&Label4, szMsg1);

  static char szMsg2[30];
  unsigned int u32[2];
  int ret = dgw_GetPresences(hDGW, u32);
  if ( ret < 0 ) usprintf(szMsg2, "Err: %d", ret);  // show Error
  else           usprintf(szMsg2, "Prssences: %x,%x", u32[1], u32[0] );  // Show DALI Presences
  LabelTextSet(&Label5, szMsg2);

  static char szMsg3[3][30];
  unsigned char LampLevel[64];
  dgw_GetAllLampsLevel(hDGW, LampLevel);
  for (int i=0; i<3; i++)
  {
    if ( (u32[0] >> i) & 1 ) // presence
         usprintf(szMsg3[i], "L%d: %d", i, LampLevel[i]); // show lamp output level
    else
         usprintf(szMsg3[i], "-"); // not presence

    LabelTextSet(pLamp[i], szMsg3[i]);
  }
}

void Timer9OnExecute(tWidget *pWidget)
{
  dgw_Process(hDGW); // Process Modbus RTU commands (response) to (from) the DGW module.
}


