﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

static const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE DGW;
DGW_CONTROL_BLOCK DGW521_dcb;
HANDLE DGW521_handle = -1;

void hmi_CheckModbus()
{
}

void _tpd_tcp_initial()
{
  if ( !lwIPLocalIPAddrGet() ) return;


  s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool DGW521_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(200/10)) == 0)
  DGW521_flag = true ;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    HMI_REQUEST_LADDER_PROCESS();}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) hmi_CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
  int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]) +1;
  if(len >= FNLen)
    memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

const char* hmi_GetCurrentFrameName()
{ return g_FrameNames[g_hmi_CurrentFrame-1];}

extern int hmi_frame_number_to_go;
void hmi_GotoFrameAction(int nFrame)
{
  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  HMI_REDRAW();
}

void hmi_GotoFrame(int nFrame)
{
  hmi_frame_number_to_go = nFrame;
}

int hmi_IndexOfFrame(const char *frame_name)
{
  for (int i=0; i<g_FrameCount; i++)
    if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
  return 0;
}

void hmi_GotoFrameByName(const char *frame_name)
{
  hmi_frame_number_to_go = hmi_IndexOfFrame(frame_name);
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}


BYTE polling_DGW521(BYTE en)
{
  if ( !VAR_VALUE(DGW521_ENABLE_DEVICE) ) return 0;
BEGIN_FUNCTION_BLOCK();

uart_SetTimeout(DGW, 200);

static const PVAR pv[] = {
&DGW521_Lamp0, &DGW521_Lamp1, &DGW521_Lamp2, &DGW521_Lamp3, &DGW521_Lamp4, &DGW521_Lamp5, &DGW521_Lamp6, &DGW521_Lamp7, &DGW521_Lamp8, &DGW521_Lamp9,
&DGW521_Lamp10, &DGW521_Lamp11, &DGW521_Lamp12, &DGW521_Lamp13, &DGW521_Lamp14, &DGW521_Lamp15 };

if ( dgw_State(DGW521_handle) < DGW_READY )
{
	dgw_Process(DGW521_handle); // init
	return HMI_ERROR;
}

// Output lamps level
for (int i=0; i<=15; i++) 
{
  if ( PVAR_FLAG_IS_WRITE(pv[i]) ) dgw_SetLampLevel(DGW521_handle, i, PVAR_READ_DEVICE(pv[i]));
}

dgw_Process(DGW521_handle);

// Get current state
unsigned char data[64];
if ( dgw_GetAllLampsLevel(DGW521_handle, data) == DGW_OK )
{
	for (int i=0; i<=15; i++)
	  PVAR_SET(pv[i], data[i]);
	return HMI_OK;  
}
else
   return HMI_ERROR;

END_FUNCTION_BLOCK();

  return 0;
}


void hmi_Connection_Process0(void)
{
  static unsigned int uiLastAccessTicks=0;
  if ( (g_TimerTicksCount - uiLastAccessTicks) < (10 / 10) )
    return;

  if (DGW521_flag)
  {
    VAR_SET(DGW521_ERROR, polling_DGW521(1)? 1:0);
    DGW521_flag = false ;
    uiLastAccessTicks = g_TimerTicksCount;
  }
}

BYTE hmi_MtmReconnectState(BYTE err, tModbusTCPDevice* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtmdev->Handle))
  {
  default:
  case STATE_TCP_IDLE:
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
      if (mtmdev->preerrsta == 2)
        mtmdev->errsta = 3;
      else if (mtmdev->preerrsta == 3)
        mtmdev->errsta = 2;
      else 
      {
        mtmdev->errsta = 2;
        mtmdev->preerrsta = 2;
      }
    } break;
  case STATE_TCP_CONNECTED:
    if (err > 0) mtmdev->errsta = 1;
    else        mtmdev->errsta = 0;
    
    break;
    }  // switch
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
  } else {
  }


  static unsigned int polling_connection=0;
  switch(polling_connection++%1) {
  case 0:
  hmi_Connection_Process0(); break;

  default: break;
  } //end switch

  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  DGW = uart_Open("COM1,9600,N,8,1");
  DGW521_handle = dgw_Init(DGW, 1, &DGW521_dcb);
  dgw_SetOperationMode(DGW521_handle, DGW_AUTO_LAMPS_GROUPS);
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_MULTI);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
